Subject: Re: make profile issue on Git 2.1.0

From: Jeff King <[email-masked]>
Date: Tue, 19 Aug 2014 02:12:03 -0400

On Sun, Aug 17, 2014 at 09:35:29PM -0500, Andrés Sicard-Ramírez wrote:

> I have the following issue on Git 2.1.0:
> 
> $ make prefix=/some-directory profile
> ...
> make[2]: Entering directory `/home/asr/src/git/git-2.1.0/t/perf'
> rm -rf test-results
> ./run
> === Running 9 tests in this tree ===
> error: No $GIT_PERF_REPO defined, and your build directory is not a repo
> error: No $GIT_PERF_REPO defined, and your build directory is not a repo
> error: No $GIT_PERF_REPO defined, and your build directory is not a repo
> error: No $GIT_PERF_REPO defined, and your build directory is not a repo
> error: No $GIT_PERF_REPO defined, and your build directory is not a repo
> error: No $GIT_PERF_REPO defined, and your build directory is not a repo
> error: No $GIT_PERF_REPO defined, and your build directory is not a repo
> error: No $GIT_PERF_REPO defined, and your build directory is not a repo
> error: No $GIT_PERF_REPO defined, and your build directory is not a repo
> cannot open test-results/p0000-perf-lib-sanity.subtests: No such file
> or directory at ./aggregate.perl line 77.
> make[2]: *** [perf] Error 2
> 
> I hadn't issues running the same command on Git 2.0.2.

This is because v2.1.0 started using "make perf" to feed the profile
builds, but it doesn't work on tarballs.

Maybe we should do this:

-- >8 --
Subject: Makefile: make perf tests optional for profile build

The perf tests need a repository to operate on; if none is
defined, we fall back to the repository containing our build
directory.  That fails, though, for an exported tarball of
git.git, which has no repository.

Since 5d7fd6d we run the perf tests as part of "make
profile". Therefore "make profile" fails out of the box on
released tarballs of v2.1.0.

We can fix this by making the perf tests optional; if they
are skipped, we still run the regular test suite, which
should give a lot of profile data (and is what we used to do
prior to 5d7fd6d anyway).

Signed-off-by: Jeff King <[email-masked]>
---
As a side note, while testing this I noticed that the "make perf" run
goes a lot faster if you set GIT_PERF_REPEAT_COUNT=1. This is bad for
actually measuring things, but probably fine for profile feedback. I
don't use the profile builds myself, though, so I will leave it to
somebody who cares more to investigate whether such a change would be a
good idea.

 Makefile | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

diff --git a/Makefile b/Makefile
index 2320de5..9f984a9 100644
--- a/Makefile
+++ b/Makefile
@@ -1659,7 +1659,11 @@ endif
 profile:: profile-clean
 	$(MAKE) PROFILE=GEN all
 	$(MAKE) PROFILE=GEN -j1 test
-	$(MAKE) PROFILE=GEN -j1 perf
+	@if test -n "$$GIT_PERF_REPO" || test -d .git; then \
+		$(MAKE) PROFILE=GEN -j1 perf; \
+	else \
+		echo "Skipping profile of perf tests..."; \
+	fi
 	$(MAKE) PROFILE=USE all
 
 profile-fast: profile-clean
-- 
2.1.0.346.ga0367b9